variables:
    DOCKER_IMAGE_NAME: "$CI_REGISTRY_IMAGE/v2/$CI_COMMIT_REF_SLUG"
    POSTGRES_HOST: postgres
    POSTGRES_USER: postgres
    POSTGRES_PASSWORD: test-pass
    POSTGRES_DB: testdb
    HELM_NAME: "golemio"
    K8S_DEPLOYMENT_NAME: output-gateway-v2
    K8S_DEPLOYMENT_IMAGE_TAG: $CI_PIPELINE_ID

cache:
    key:
        files:
            - package-lock.json
    paths:
        - node_modules

stages:
    - pre-test
    - test
    - build
    - release
    - deploy

include:
    - template: "Workflows/Branch-Pipelines.gitlab-ci.yml"
    - project: "operator-ict/devops/gitlab-ci-pipeline"
      file:
          - "/golemio-globals/service-versions.yml"
          - "/docker/simple-build.yml"
          - "/k8s-golemio/helm-golemio-deploy.yml"
          - "/docs/golemio-gitlab-docs-pages.yml"
          - "/npm/bump-dependencies.yml"

.run_tests:
    stage: test
    image: node:20.18.0-alpine
    coverage: '/All files[^|]*\|[^|]*\s+([\d\.]+)/'
    services:
        - !reference [.postgis-image]
        - redis:7.2.1-alpine
    script:
        - npm install --ignore-scripts --progress=false
        # Audit production dependencies for HIGH vulnerabilities
        - npm audit --omit dev --audit-level critical
        - npm run lint
        - npm run build-apidocs
        - npm run build-apidocs-public
        - npm run build
        - export POSTGRES_MIGRATIONS_DIR="node_modules/@golemio/db-common/db/migrations/**/postgresql"
        - export POSTGRES_CONN=postgres://$POSTGRES_USER:$POSTGRES_PASSWORD@$POSTGRES_HOST/$POSTGRES_DB
        - npm install --ignore-scripts --progress=false
        - npx golemio migrate-db up --silent
        - export LOG_LEVEL=INFO
        - export POSTGRES_CONN=postgres://$POSTGRES_USER:$POSTGRES_PASSWORD@$POSTGRES_HOST/$POSTGRES_DB
        - export SENTRY_ENABLE=false
        - export REDIS_ENABLE=false
        - export REDIS_CONN=redis://redis/
        # Only data from the parkings module are required for tests
        - export SQL_DUMP_FILES=node_modules/@golemio/parkings/db/example/*.sql
        - export POSTGRES_MIGRATIONS_DIR=node_modules/@golemio/parkings/db/migrations/**/postgresql
        # Run migrations from modules
        - npx golemio migrate-db up --silent
        # Import postgres test data
        - npx golemio import-db-data
        - npm run code-coverage
    tags:
        - docker
    rules:
        - if: $SKIP_TEST_AND_STAGES_AFTER
          when: never
        - when: always
    artifacts:
        when: always
        reports:
            junit: junit.xml
            coverage_report:
                coverage_format: cobertura
                path: coverage/cobertura-coverage.xml

run_tests:
    extends: .run_tests
    image: node:20.18.0-alpine
# run_tests-node-next:
#     extends: .run_tests
#     image: node:20.18.0-alpine
#     allow_failure: true
